;;; 
;;; CYCORD(X,Y)

;;;

(def-calculus "CYCORD Calculus (CC)"
  :arity :ternary
  :basis-entity :1d-point ;; orientation
  :parametric? nil
  ;;:qualifier (external-lib "libdcc.dylib" "cc_qualify")
  :identity-relation e
  :inverse-operation (( eee eee )
		      ( ell lre )
		      ( eoo ooe )
		      ( err rle )
		      ( lel lel )
		      ( lll lrl )
		      ( llo orl )
		      ( llr rrl )
		      ( lor rol )
		      ( lre ell )
		      ( lrl lll )
		      ( lrr rll )
		      ( oeo oeo )
		      ( olr rro )
		      ( ooe eoo )
		      ( orl llo )
		      ( rer rer )
		      ( rle err )
		      ( rll lrr )
		      ( rlr rrr )
		      ( rol lor )
		      ( rrl llr )
		      ( rro olr )
		      ( rrr rlr )
		      )
  
  :rotation-operation (( eee eee )
		       ( ell lre )
		       ( eoo ooe )
		       ( err rle )
		       ( lel err )
		       ( lll lrr )
		       ( llo lor )
		       ( llr llr )
		       ( lor olr )
		       ( lre rer )
		       ( lrl rrr )
		       ( lrr rlr )
		       ( oeo eoo )
		       ( olr llo )
		       ( ooe oeo )
		       ( orl rro )
		       ( rer ell )
		       ( rle lel )
		       ( rll lrl )
		       ( rlr lll )
		       ( rol orl )
		       ( rrl rrl )
		       ( rro rol )
		       ( rrr rll )
		       )
  
  :base-relations ( eee ell eoo err 
		    lel lll llo llr 
		    lor lre lrl lrr 
		    oeo olr ooe orl 
		    rer rle rll rlr 
		    rol rrl rro rrr )
  
  :composition-operation ( 
			  ;; Case 1: b3 = b1' = e
			  ( eee eee (eee))
			  ( eee ell (ell))
			  ( eee eoo (eoo))
			  ( eee err (err))
			  ( lre eee (lre))
			  ( lre ell (lel ell lrl)) ;; E1
			  ( lre eoo (llo))
			  ( lre err (llr lor lrr)) ;; E2
			  ( ooe eee (ooe))
			  ( ooe ell (orl))
			  ( ooe eoo (oeo))
			  ( ooe err (olr))
			  ( rle eee (rle))
			  ( rle ell (rll rol rrl)) ;; E4
			  ( rle eoo (rro))
			  ( rle err (rer rlr rrr)) ;; E3

			  ;; Case 2: b3 = b1' = l
			  ( ell lel (ell))
			  ( ell lll (ell))
			  ( ell llo (eoo))
			  ( ell llr (err))
			  ( ell lor (err))
			  ( ell lre (eee))
			  ( ell lrl (ell))
			  ( ell lrr (err))
			  ( lel lel (lel))
			  ( lel lll (lll))
			  ( lel llo (llo))
			  ( lel llr (llr))
			  ( lel lor (lor))
			  ( lel lre (lre))
			  ( lel lrl (lrl))
			  ( lel lrr (lrr))

			  ( lll lel (lll))
			  ( lll lll (lll))
			  ( lll llo (llo))
			  ( lll llr (llr lor lrr)) ;; E2
			  ( lll lor (lrr))
			  ( lll lre (lre))
			  ( lll lrl (lel ell lrl)) ;; E1
			  ( lll lrr (lrr))

			  ( lrl lel (lrl))
			  ( lrl lll (lel ell lrl)) ;; E1
			  ( lrl llo (llo))
			  ( lrl llr (llr))
			  ( lrl lor (llr))
			  ( lrl lre (lre))
			  ( lrl lrl (lrl))
			  ( lrl lrr (llr lor lrr)) ;; E2

			  ( orl lel (orl))
			  ( orl lll (orl))
			  ( orl llo (oeo))
			  ( orl llr (olr))
			  ( orl lor (olr))
			  ( orl lre (ooe))
			  ( orl lrl (orl))
			  ( orl lrr (olr))

			  ( rll lel (rll))
			  ( rll lll (rll rol rrl)) ;; E4
			  ( rll llo (rro))
			  ( rll llr (rrr))
			  ( rll lor (rrr))
			  ( rll lre (rle))
			  ( rll lrl (rll))
			  ( rll lrr (rer rlr rrr)) ;; E3

			  ( rol lel (rol))
			  ( rol lll (rrl))
			  ( rol llo (rro))
			  ( rol llr (rrr))
			  ( rol lor (rer))
			  ( rol lre (rle))
			  ( rol lrl (rll))
			  ( rol lrr (rlr))

			  ( rrl lel (rrl))
			  ( rrl lll (rrl))
			  ( rrl llo (rro))
			  ( rrl llr (rer rlr rrr)) ;; E3
			  ( rrl lor (rlr))
			  ( rrl lre (rle))
			  ( rrl lrl (rll rol rrl)) ;; E4
			  ( rrl lrr (rlr))
			  
			  ;; Case 3: b3 = b1' = o
			  ( eoo oeo (eoo))
			  ( eoo olr (err))
			  ( eoo ooe (eee))
			  ( eoo orl (ell))
			  ( llo oeo (llo))
			  ( llo olr (llr lor lrr)) ;; E2
			  ( llo ooe (lre))
			  ( llo orl (lel lll lrl)) ;; E1
			  ( oeo oeo (oeo))
			  ( oeo olr (olr))
			  ( oeo ooe (ooe))
			  ( oeo orl (orl))
			  ( rro oeo (rro))
			  ( rro olr (rer rlr rrr)) ;; E3
			  ( rro ooe (rle))
			  ( rro orl (rll rol rrl)) ;; E4

			  ;; Case 4: b3 = b1' = r
			  ( err rer (err))
			  ( err rle (eee))
			  ( err rll (ell))
			  ( err rlr (err))
			  ( err rol (ell))
			  ( err rrl (ell))
			  ( err rro (eoo))
			  ( err rrr (err))

			  ( llr rer (llr))
			  ( llr rle (lre))
			  ( llr rll (lrl))
			  ( llr rlr (llr lor lrr)) ;; E2
			  ( llr rol (lrl))
			  ( llr rrl (lel ell lrl)) ;; E1
			  ( llr rro (llo))
			  ( llr rrr (llr))

			  ( lor rer (lor))
			  ( lor rle (lre))
			  ( lor rll (lrl))
			  ( lor rlr (lrr))
			  ( lor rol (lel))
			  ( lor rrl (lll))
			  ( lor rro (llo))
			  ( lor rrr (llr))

			  ( lrr rer (lrr))
			  ( lrr rle (lre))
			  ( lrr rll (lel ell lrl)) ;; E1
			  ( lrr rlr (lrr))
			  ( lrr rol (lll))
			  ( lrr rrl (lll))
			  ( lrr rro (llo))
			  ( lrr rrr (llr lor lrr)) ;; E2

			  ( olr rer (olr))
			  ( olr rle (ooe))
			  ( olr rll (orl))
			  ( olr rlr (olr))
			  ( olr rol (orl))
			  ( olr rrl (orl))
			  ( olr rro (oeo))
			  ( olr rrr (olr))

			  ( rer rer (rer))
			  ( rer rle (rle))
			  ( rer rll (rll))
			  ( rer rlr (rlr))
			  ( rer rol (rol))
			  ( rer rrl (rrl))
			  ( rer rro (rro))
			  ( rer rrr (rrr))

			  ( rlr rer (rlr))
			  ( rlr rle (rle))
			  ( rlr rll (rll rol rrl)) ;; E4
			  ( rlr rlr (rlr))
			  ( rlr rol (rrl))
			  ( rlr rrl (rrl))
			  ( rlr rro (rro))
			  ( rlr rrr (rer rlr rrr)) ;; E3

			  ( rrr rer (rrr))
			  ( rrr rle (rle))
			  ( rrr rll (rll))
			  ( rrr rlr (rer rlr rrr)) ;; E3
			  ( rrr rol (rll))
			  ( rrr rrl (rll rol rrl)) ;; E4
			  ( rrr rro (rro))
			  ( rrr rrr (rrr))
			  )
) ;; end def-calculus
